#include <Tle493d_a2b6.h>
Tle493d_a2b6 Tle493dMagnetic3DSensor = Tle493d_a2b6(Tle493d::FASTMODE,Tle493d::TLE493D_A0);

float TPI = 13; // threads per inch
float DPS = 1.8; // degrees per full step
float FULLROT = 360; //

int currX = 0;
int currY = 0;
int currZ = 0;

int targX = .5*TPI*FULLROT/DPS;
int targY = 0;
int targZ = 0;

bool hitX = 0;
bool hitY = 0;
bool hitZ = 0;

//#define output(pin) (PORT->Group[0].DIRSET.reg = pin)
//#define set(pin) (PORT_IOBUS->Group[0].OUTSET.reg = pin)
//#define clr(pin) (PORT_IOBUS->Group[0].OUTCLR.reg = pin)
//#define compare(value,pin) (value > pulse) ? set(pin) : clear(pin)

#define Xpos 2
#define Xneg 3
#define Ypos 4
#define Yneg 5
#define Zpos 6
#define Zneg 7
#define LED 11

void setup() {
  Serial.begin(9600);
  while (!Serial);
  
  pinMode(Xpos,OUTPUT);
  pinMode(Xneg,OUTPUT);
  pinMode(Ypos,OUTPUT);
  pinMode(Yneg,OUTPUT);
  pinMode(Zpos,OUTPUT);
  pinMode(Zneg,OUTPUT);
  
  pinMode(LED,OUTPUT);
  digitalWriteFast(LED,HIGH);
  
  Tle493dMagnetic3DSensor.begin();
  Tle493dMagnetic3DSensor.enableTemp();
}

void loop() {
  if(targX>currX){
    digitalWriteFast(Xpos,HIGH);
    currX += 1;
    hitX = 0;
  }
  else if(targX<currX){
    digitalWriteFast(Xneg,HIGH);
    currX -= 1;
    hitX = 0;
  }
  else{
    hitX = 1;
  }
  if(targY>currY){
    digitalWriteFast(Ypos,HIGH);
    currY += 1;
    hitY = 0;
  }
  else if(targY<currY){
    digitalWriteFast(Yneg,HIGH);
    currY -= 1;
    hitY = 0;
  }
  else{
    hitY = 1;
  }
  if(targZ>currZ){
    digitalWriteFast(Zpos,HIGH);
    currZ += 1;
    hitZ = 0;
  }
  else if(targZ<currZ){
    digitalWriteFast(Zneg,HIGH);
    currZ -= 1;
    hitZ = 0;
  }
  else{
    hitZ = 1;
  }
  
  delay(2);

  if((hitX+hitY+hitZ)<3){
    digitalWriteFast(LED,HIGH);
    Tle493dMagnetic3DSensor.updateData();
    Serial.print(currX*DPS/(TPI*FULLROT),4);
    Serial.print(" ; ");
    Serial.print(currY*DPS/(TPI*FULLROT),4);
    Serial.print(" ; ");
    Serial.print(currZ*DPS/(TPI*FULLROT),4);
    Serial.print(" ; ");
    Serial.print(Tle493dMagnetic3DSensor.getX());
    Serial.print(" ; ");
    Serial.print(Tle493dMagnetic3DSensor.getY());
    Serial.print(" ; ");
    Serial.println(Tle493dMagnetic3DSensor.getZ());
  }
  else{
    digitalWriteFast(LED,LOW);
    Serial.println(".");
  }
  
  digitalWriteFast(Xpos,LOW);
  digitalWriteFast(Xneg,LOW);
  digitalWriteFast(Ypos,LOW);
  digitalWriteFast(Yneg,LOW);
  digitalWriteFast(Zpos,LOW);
  digitalWriteFast(Zneg,LOW);
}
